package kdispersao;

import java.util.Vector;

public class AG {
  int n; //Numero de Cidades
  int distCidades[][]; //Distancia entre cidades
  String cids[]; //Nomes das Cidades
  int k; //Numero de Cidades Requerido; --> K
  int nind; //Numero de Individuos do AG

  int pop[][]; // populacao []linha[]coluna
  int inv_pop[]; // quantidade de inviabilidade de cada individuo
  int mdistancia_pop[]; // distancia minima total de cada individuo
  int pop_sobrev[][]; // populacao sobrevivente
  int inv_pop_sobrev[]; // quantidade de inviabilidade de cada individuo da populacao sobrevivente
  int mdistancia_pop_sobrev[]; //distancia minima total de cada individuo da populacao sobrevivente
  int s_star[]; // vetor que contem a melhor solucao gerada
  int mdistancia_star = 0; // Maior distancia minima total
  double prob_crossover; //Probabilidade de Crossover
  double prob_mutacao; //Probabilidade de Mutacao
  int max_geracoes; //Numero maximo de geracoes
  mResult res;

  Gravador g;

  public AG(int no,
            int distCidadeso[][],
            String cidso[],
            int nindo,
            int ko,
            double prob_crossovero,
            double prob_mutacaoo,
            int max_geracoeso,
            Gravador go,mResult reso) {
    n = no;
    distCidades = distCidadeso;
    k = ko;
    nind = nindo;
    prob_crossover = prob_crossovero;
    prob_mutacao = prob_mutacaoo;
    max_geracoes = max_geracoeso;
    cids = cidso;
    g = go;
    res = reso;

    s_star = new int[n];
    if (nind % 2 != 0) {
      //System.out.println("Numero de individuos deve ser par!");
      //System.out.println("Vou aumentar o numero de individuos ...\n");
      nind++;
    }
    nind *= 2;
    pop = new int[nind][n];
    init(pop);
    inv_pop = new int[nind];
    init(inv_pop);
    mdistancia_pop = new int[nind];
    init(mdistancia_pop);
    pop_sobrev = new int[nind / 2][n];
    init(pop_sobrev);
    inv_pop_sobrev = new int[nind / 2];
    init(inv_pop_sobrev);
    mdistancia_pop_sobrev = new int[nind / 2];
    init(mdistancia_pop_sobrev);
    //System.out.println("Populacao inicial:");
    /* Geracao da populacao inicial */
    for (int j = 0; j < nind / 2; j++) {
      constroi_solucao_aleatoria(j);
      //imprime_solucao(pop[j],n);
      mdistancia_pop[j] = calcula_distancia(j);
      inv_pop[j] = calcula_inviabilidade(j);
      //System.out.println("Individuo = "+j+"; Menor Distancia = "+mdistancia_pop[j]+"; Inviabilidade = "+inv_pop[j]+"\n");
      if (inv_pop[j] != 0) {
        repara_inviabilidade(j, inv_pop[j]);
        /*System.out.println("Individuo Reparado = " + j + "; Menor Distancia = " +
                           mdistancia_pop[j] + "; Inviabilidade = " + inv_pop[j] +
                           "\n");*/
        imprime_solucao(j);
      }
      if (mdistancia_pop[j] > mdistancia_star) {
        mdistancia_star = mdistancia_pop[j];
        atualiza_melhor_solucao(j);
        //System.out.println("Encotrou solucao melhor: ");
        imprime_solucao(j);
        /*System.out.println("Individuo = " + j + "; Menor Distancia = " +
                           mdistancia_pop[j] + "; Inviabilidade = " + inv_pop[j]);*/
      }
    }
    /*System.out.println("Distancia Minima do melhor individuo inicial = " +
                       mdistancia_star);*/

    int ngeracoes = 0;
    while (ngeracoes < max_geracoes) {
      //System.out.println(ngeracoes+1+" Geracao\n--------------");
    ngeracoes++;
    /* Aplicar crossover */
    int quant_filhos = 0;
    while (quant_filhos < nind / 2) {
      /* Selecao aleatoria de pais */
      int jpai1, jpai2;
      do {
        jpai1 = random(nind / 2);
        jpai2 = random(nind / 2);
      }
      while (jpai1 == jpai2);
      if (randomico(0, 1) < prob_crossover) {
        int ponto_de_corte = random(n);
        crossover(pop[jpai1], pop[jpai2], pop[quant_filhos + nind / 2],
                  pop[quant_filhos + nind / 2 + 1], n, ponto_de_corte);
        quant_filhos += 2;
      }
    }
    //System.out.println("Filhos Apos Crossover:");
    for (int i = nind / 2; i < nind; i++)
      imprime_solucao(i);

    for (int j = 0; j < nind; j++)
      if (randomico(0, 1) < prob_mutacao)
        mutacao(pop[j], n);

    //System.out.println("Filhos Apos Mutacao:");
    for (int i = nind / 2; i < nind; i++)
      imprime_solucao(i);
      /* Avaliar a populacao inteira (pais e filhos) */
    for (int j = 0; j < nind; j++) {
      inv_pop[j] = calcula_inviabilidade(j);
      if (inv_pop[j] == 0) {
        mdistancia_pop[j] = calcula_distancia(j);
        /*System.out.println("Individuo = " + j + "; Menor Distancia = " +
                           mdistancia_pop[j] + "; Inviabilidade = " +
                           inv_pop[j]);*/
      }
      else {
        repara_inviabilidade(j, inv_pop[j]);
        mdistancia_pop[j] = calcula_distancia(j);
        /*System.out.println("Individuo Reparado = " + j +
                           "; Menor Distancia = " +
                           mdistancia_pop[j] + "; Inviabilidade Reparada = " +
                           inv_pop[j]);*/
      }
      if (mdistancia_pop[j] > mdistancia_star) {
        mdistancia_star = mdistancia_pop[j];
        atualiza_melhor_solucao(j);
        //System.out.println("Encotrou solucao melhor: ");
        imprime_solucao(j);
        /*System.out.println("Individuo = " + j + "; Menor Distancia = " +
                           mdistancia_pop[j] + "; Inviabilidade = " +
                           inv_pop[j]);*/
      }
    }
    /* Definir a populacao sobrevivente */
    /* distanciea de todos os individuos da populacao, isto e', pais e filhos */
    /*for (int j = 0; j < nind; j++)
      System.out.println("mdistancia_pop[" + j + "] = " + mdistancia_pop[j]);*/
    for (int j = 0; j < nind / 2; j++) {
      /* escolha dos individuos sobreviventes pelo mecanismo da roleta russa */
      int individuo_escolhido = roleta(nind, mdistancia_pop);
      /*System.out.println("Individuo escolhido para proxima geracao = " +
                         individuo_escolhido);*/
      for (int i = 0; i < n; i++)
      pop_sobrev[j][i] = pop[individuo_escolhido][i];
      mdistancia_pop_sobrev[j] = mdistancia_pop[individuo_escolhido];
      inv_pop_sobrev[j] = inv_pop[individuo_escolhido];
    }
    /* Zerar a populacao e seus dados */
      init(inv_pop);
      init(mdistancia_pop);
      init(pop);
      /* Primeira metade da populacao <-- populacao sobrevivente */
      for (int j = 0; j < nind / 2; j++) {
        for (int i = 0; i < n; i++)
        pop[j][i] = pop_sobrev[j][i];
        mdistancia_pop[j] = mdistancia_pop_sobrev[j];
        inv_pop[j] = inv_pop_sobrev[j];
      }
      /* mdistancia_pop dos individuos sobreviventes */
      for (int j=0; j<nind/2; j++)
        //System.out.println("Sobrevivente: distancia_pop["+j+"] = "+mdistancia_pop[j]);
      /* Zerar a matriz e os vetores que armazenam os dados da populacao sobrevivente */
      init(inv_pop_sobrev);
      init(mdistancia_pop_sobrev);
      init(pop_sobrev);
    }
    for (int j=0;j<nind;j++) {
      if (mdistancia_pop[j] > mdistancia_star) {
        mdistancia_star = mdistancia_pop[j];
        atualiza_melhor_solucao(j);
      }
    }
    System.out.println("\n-------------------------------------\n");
    System.out.println("Melhor solucao: ");
    imprime_solucao(s_star);
    System.out.println("Maior Dist Minima: "+mdistancia_star);
    int melhor[] = quemEMelhor(s_star);
    System.out.println("Cidades Escolhidas:");
    for (int i=0;i<k;i++){
      System.out.println(cids[melhor[i]]+": "+melhor[i]);
    }
    System.out.println("-------------------------------------\n");
    if (res.getStar() < mdistancia_star) {
      res = new mResult(s_star,mdistancia_star,melhor,n,k,prob_crossover,prob_mutacao,max_geracoes,cids);
      Principal.setREs(res);
    }
    System.out.println("Melhor ate entao: "+res.getStar());

//------------------------------------------------------------------------------
  }
  int[] quemEMelhor(int[] g) {
    int m[] = new int[k];
    int c =0;
    for (int i=0;i<g.length;i++){
      if (g[i] ==1) {
       m[c] = i;
       c++;
      }
    }
    return m;
  }
      /* Esta rotina devolve o individuo escolhido pelo mecanismo da roleta russa */
  int roleta(int nind, int mdistancia_pop[]) {
    //System.out.println("Roleta Russa:\n---------------");
    double aux;
    double escala[], fracao[];
    int escolhido;
    int l;
    fracao = new double[nind];
    escala = new double[nind];
    int soma = 0;
    for (int j = 0; j < nind; j++) {
      soma += mdistancia_pop[j];
      //System.out.println("mdistancia_pop[" + j + "] = " + mdistancia_pop[j]);
    }
    for (int j = 0; j < nind; j++) {
      fracao[j] = (double) mdistancia_pop[j] / soma;
      //System.out.println("fracao[" + j + "] = " + fracao[j]);
    }
    escala[0] = fracao[0];
    //System.out.println("escala[0] = " + escala[0]);
    for (int j = 1; j < nind; j++) {
      escala[j] = escala[j - 1] + fracao[j];
      //System.out.println("escala[" + j + "] = " + escala[j]);
    }
    aux = randomico(0, 1);
    l = 0;
    while (escala[l] <= aux)
      l++;
    escolhido = l;
    return escolhido;
  }

  public void atualiza_melhor_solucao(int j) {
    for (int i = 0; i < n; i++) {
      s_star[i] = pop[j][i];
    }
  }

  public void crossover(int pai1[],
                        int pai2[],
                        int filho1[],
                        int filho2[],
                        int n,
                        int ponto_de_corte) {
    for (int j = 0; j < ponto_de_corte; j++) {
      filho1[j] = pai1[j];
      filho2[j] = pai2[j];
    }
    for (int j = ponto_de_corte; j < n; j++) {
      filho1[j] = pai2[j];
      filho2[j] = pai1[j];
    }
  }

  public void mutacao(int s[], int n) {
    int j;
    j = random(n);
    if (s[j] == 1)
      s[j] = 0;
    else
      s[j] = 1;
  }

  public int random(int i) {
    return (int) (Math.random() * i);
  }

  public double randomico(int i, int f) {
    return i + (Math.random() * f);
  }

  public void imprime_solucao(int j) {
    String out = "";
    for (int i = 0; i < n; i++) {
      out += pop[j][i] + " ";
    }
    //System.out.println(out);
  }
  public void imprime_solucao(int j[]) {
    String out = "";
    for (int i = 0; i < n; i++) {
      out += j[i] + " ";
    }
    //System.out.println(out);
  }


  public void constroi_solucao_aleatoria(int j) {
    int b = 0;
    boolean ok;
    for (int i = 0; i < k; i++) {
      ok = false;
      while (!ok) {
        b = (int) (Math.random() * n);
        if (pop[j][b] == 0) {
          ok = true;
        }
      }
      pop[j][b] = 1;
    }
    imprime_solucao(j);
  }

  public int calcula_distancia(int j) {
    int mdist = 50000;
    int a[] = new int[k];
    //Coloca em a as Cidades p/ calcular a dist.
    int t = 0;
    for (int i = 0; i < n; i++) {
      if (pop[j][i] == 1) {
        a[t] = i;
        t++;
      }
    }
    int g = 1;
    for (int h = 0; h < a.length - 1; h++) {
      for (int i = g; i < a.length; i++) {
        //System.out.println("Verificando h="+h+" ["+a[h]+"] i="+i+" ["+a[i]+"]");
        if (mdist > distCidades[a[h]][a[i]])
          mdist = distCidades[a[h]][a[i]];
      }
      g++;
    }

    return mdist;
  }

  public int calcula_inviabilidade(int j) {
    int inv = 0;
    for (int i = 0; i < n; i++) {
      if (pop[j][i] == 1)
        inv++;
    }
    if (inv != k)
      return inv;
    return 0;
  }

  public void repara_inviabilidade(int j, int inv) {
    int b = 0;
    int x = 1;
    int y = 0;
    if (inv < k) {
      x = 0;
      y = 1;
    }
    boolean ok = false;
    while (!ok) {
      b = (int) (Math.random() * n);
      if (pop[j][b] == x) {
        ok = true;
      }
    }
    pop[j][b] = y;
    inv = calcula_inviabilidade(j);
    if (inv != 0)
      repara_inviabilidade(j, inv);
  }

  public void init(int[][] a) {
    for (int i = 0; i < a.length; i++) {
      for (int j = 0; j < a[i].length; j++) {
        a[i][j] = 0;
      }
    }
  }
  public void init(int[] a) {
    for (int i = 0; i < a.length; i++) {
      a[i] = 0;
    }
  }

}